
#include <mega32.h>
#include <delay.h>

#define ZERO PORTC=0  // 0     
#define BLACK PORTC=1 // 0.3   
#define WHITE PORTC=2 // 0.7-1.0   

#define vcol  286    //    

#define shortsyncZ  3   //   
#define shortsyncB  29  //    

#define longsyncZ  27   //   
#define longsyncB  5    //    

unsigned int i;

//   5   (  l,m)
//  last_p -     
//      last_p=0 -    27
//      last_p!=0 -   61
void shortsi(unsigned int last_p) {

        ZERO;  delay_us(shortsyncZ);                                
        BLACK; delay_us(shortsyncB);

        ZERO;  delay_us(shortsyncZ);                                                  
        BLACK; delay_us(shortsyncB);

        ZERO;  delay_us(shortsyncZ);                         
        BLACK; delay_us(shortsyncB);                
        
        ZERO;  delay_us(shortsyncZ);                                                  
        BLACK; delay_us(shortsyncB);

        ZERO;  delay_us(shortsyncZ);                         
        BLACK;
        if (last_p==0) delay_us(shortsyncB);
            else       delay_us(61);
}

//   5   (  n)
void longsi(void) {
        ZERO;  delay_us(longsyncZ);                
        BLACK; delay_us(longsyncB);

        ZERO;  delay_us(longsyncZ);                
        BLACK; delay_us(longsyncB);

        ZERO;  delay_us(longsyncZ);                
        BLACK; delay_us(longsyncB);

        ZERO;  delay_us(longsyncZ);                 
        BLACK; delay_us(longsyncB);                 
        
        ZERO;  delay_us(longsyncZ);                
        BLACK; delay_us(longsyncB);                 
}

void main(void)
{
    DDRC = 1<<DDC0|1<<DDC1;     //   
    
    while(1) {
        //  

        //  

        shortsi(shortsyncB);     //    
         
        longsi();                //   
                                                    
        shortsi(0);              //     
                                                      
        i=6;
        while (i<24) {                      // 6-23  () 
          ZERO;  delay_us(4);                
          BLACK; delay_us(59);
          i++;                
        }     
       //   ---------------------------------------------------------------------                                   
       
        // 288  ,  24  311 

        for(i=0;i<100;i++) {            //  
          ZERO;  delay_us(4);                
          BLACK; delay_us(59);
        }                     
       
        for(i=100;i<200;i++) {           //  

           ZERO;  delay_us(4);      
           BLACK; delay_us(18); 
           WHITE;
           delay_us(2);
           BLACK;
           delay_us(39);        
        }

        for(i=200;i<vcol+1;i++) {          //    311
          ZERO;  delay_us(4);                
          BLACK; delay_us(59);        
       }


        //  
        //   -----------------------------------------------------------------

        shortsi(shortsyncB);        //    
         
        longsi();                   //   
        
        shortsi(59);                //   ,       
                           
        i=319;
        while (i<336) {                      // 319-335  () 
          ZERO;  delay_us(4);                
          BLACK; delay_us(59);
          i++;                
        }     
        //    --------------------------------------------------------------
               
        // 288  ,  623 
        for(i=0;i<100;i++) {
          ZERO;  delay_us(4);                
          BLACK; delay_us(59);        
        }                     
       
        for(i=100;i<200;i++) { //  
           ZERO;  delay_us(4);      
           BLACK; delay_us(18); 
           WHITE;
           delay_us(2);
           BLACK;
           delay_us(39);        
        }

        for(i=200;i<vcol+1;i++) {  //  ,  623 ,      
          ZERO;  delay_us(4);                
          BLACK; delay_us(59);        
       }

        ZERO;  delay_us(4);                 // 623 -                       
        BLACK; delay_us(28);                //  ,                                                 
       
    }
}